// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.measure;

import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.data.vessel.feature.physical.VesselPhysicalFeatures;
import fr.ifremer.adagio.core.dao.referential.AnalysisInstrument;
import fr.ifremer.adagio.core.dao.referential.NumericalPrecision;
import fr.ifremer.adagio.core.dao.referential.PrecisionType;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel;
import fr.ifremer.adagio.core.dao.referential.pmfm.Pmfm;
import fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue;
import java.util.Date;

/**
 * 
 */
// HibernateEntity.vsl annotations merge-point
public abstract class VesselPhysicalMeasurement
    extends MeasurementImpl
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 8575071086824440527L;

    // Generate 0 attributes
    // Generate 1 associations
    private VesselPhysicalFeatures vesselPhysicalFeatures;

    /**
     * Caractéristiques physique d'un navire (navire de peche ou océanographique, ou autres).
     * @return this.vesselPhysicalFeatures VesselPhysicalFeatures
     */
    public VesselPhysicalFeatures getVesselPhysicalFeatures()
    {
        return this.vesselPhysicalFeatures;
    }

    /**
     * Caractéristiques physique d'un navire (navire de peche ou océanographique, ou autres).
     * @param vesselPhysicalFeaturesIn VesselPhysicalFeatures
     */
    public void setVesselPhysicalFeatures(VesselPhysicalFeatures vesselPhysicalFeaturesIn)
    {
        this.vesselPhysicalFeatures = vesselPhysicalFeaturesIn;
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>MeasurementImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.measure.Measurement#equals(Object)
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>MeasurementImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.measure.Measurement#hashCode()
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link VesselPhysicalMeasurement}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link VesselPhysicalMeasurement}.
         * @return new VesselPhysicalMeasurementImpl()
         */
        public static VesselPhysicalMeasurement newInstance()
        {
            return new VesselPhysicalMeasurementImpl();
        }

        /**
         * Constructs a new instance of {@link VesselPhysicalMeasurement}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param qualityFlag QualityFlag
         * @param pmfm Pmfm
         * @param vesselPhysicalFeatures VesselPhysicalFeatures
         * @return newInstance
         */
        public static VesselPhysicalMeasurement newInstance(QualityFlag qualityFlag, Pmfm pmfm, VesselPhysicalFeatures vesselPhysicalFeatures)
        {
            final VesselPhysicalMeasurement entity = new VesselPhysicalMeasurementImpl();
            entity.setQualityFlag(qualityFlag);
            entity.setPmfm(pmfm);
            entity.setVesselPhysicalFeatures(vesselPhysicalFeatures);
            return entity;
        }

        /**
         * Constructs a new instance of {@link VesselPhysicalMeasurement}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param numericalValue Float
         * @param alphanumericalValue String
         * @param digitCount Integer
         * @param precisionValue Float
         * @param controlDate Date
         * @param validationDate Date
         * @param qualificationDate Date
         * @param qualificationComments String
         * @param remoteId Integer
         * @param aggregationLevel AggregationLevel
         * @param qualityFlag QualityFlag
         * @param precisionType PrecisionType
         * @param analysisInstrument AnalysisInstrument
         * @param numericalPrecision NumericalPrecision
         * @param department Department
         * @param pmfm Pmfm
         * @param qualitativeValue QualitativeValue
         * @param vesselPhysicalFeatures VesselPhysicalFeatures
         * @return newInstance VesselPhysicalMeasurement
         */
        public static VesselPhysicalMeasurement newInstance(Float numericalValue, String alphanumericalValue, Integer digitCount, Float precisionValue, Date controlDate, Date validationDate, Date qualificationDate, String qualificationComments, Integer remoteId, AggregationLevel aggregationLevel, QualityFlag qualityFlag, PrecisionType precisionType, AnalysisInstrument analysisInstrument, NumericalPrecision numericalPrecision, Department department, Pmfm pmfm, QualitativeValue qualitativeValue, VesselPhysicalFeatures vesselPhysicalFeatures)
        {
            final VesselPhysicalMeasurement entity = new VesselPhysicalMeasurementImpl();
            entity.setNumericalValue(numericalValue);
            entity.setAlphanumericalValue(alphanumericalValue);
            entity.setDigitCount(digitCount);
            entity.setPrecisionValue(precisionValue);
            entity.setControlDate(controlDate);
            entity.setValidationDate(validationDate);
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setRemoteId(remoteId);
            entity.setAggregationLevel(aggregationLevel);
            entity.setQualityFlag(qualityFlag);
            entity.setPrecisionType(precisionType);
            entity.setAnalysisInstrument(analysisInstrument);
            entity.setNumericalPrecision(numericalPrecision);
            entity.setDepartment(department);
            entity.setPmfm(pmfm);
            entity.setQualitativeValue(qualitativeValue);
            entity.setVesselPhysicalFeatures(vesselPhysicalFeatures);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(VesselPhysicalMeasurement o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// VesselPhysicalMeasurement.java merge-point
}